Index: squid/src/auth/ntlm/helpers/NTLMSSP/ntlm_auth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/ntlm/helpers/NTLMSSP/Attic/ntlm_auth.c,v
retrieving revision 1.1.2.11
retrieving revision 1.1.2.12
diff -u -r1.1.2.11 -r1.1.2.12
--- squid/src/auth/ntlm/helpers/NTLMSSP/ntlm_auth.c	9 Feb 2001 14:37:07 -0000	1.1.2.11
+++ squid/src/auth/ntlm/helpers/NTLMSSP/ntlm_auth.c	10 Feb 2001 17:32:49 -0000	1.1.2.12
@@ -23,10 +23,10 @@
 #include "smbval/rfcnb-error.h"
 
 /* these are part of rfcnb-priv.h and smblib-priv.h */
-extern int SMB_Get_Error_Msg (int msg, char *msgbuf, int len);
-extern int SMB_Get_Last_Error ();
-extern int SMB_Get_Last_SMB_Err ();
-extern int RFCNB_Get_Last_Error ();
+extern int SMB_Get_Error_Msg(int msg, char *msgbuf, int len);
+extern int SMB_Get_Last_Error();
+extern int SMB_Get_Last_SMB_Err();
+extern int RFCNB_Get_Last_Error();
 
 #include <errno.h>
 
@@ -60,62 +60,54 @@
 /* housekeeping cycle and periodic operations */
 static unsigned char need_dc_resurrection = 0;
 static void
-resurrect_dead_dc ()
+resurrect_dead_dc()
 {
-  int j;
-  dc *c = controllers;
+    int j;
+    dc *c = controllers;
 
-  need_dc_resurrection = 0;
-  for (j = 0; j < numcontrollers; j++)
-    if (c->status != DC_OK && is_dc_ok (c->domain, c->controller))
-      c->status = DC_OK;
+    need_dc_resurrection = 0;
+    for (j = 0; j < numcontrollers; j++)
+	if (c->status != DC_OK && is_dc_ok(c->domain, c->controller))
+	    c->status = DC_OK;
 }
 
 /* makes a null-terminated string upper-case. Changes CONTENTS! */
 static void
-uc (char *string)
+uc(char *string)
 {
-  char *p = string, c;
-  while ((c = *p))
-    {
-      *p = toupper (c);
-      p++;
+    char *p = string, c;
+    while ((c = *p)) {
+	*p = toupper(c);
+	p++;
     }
 }
 
 /* makes a null-terminated string lower-case. Changes CONTENTS! */
 static void
-lc (char *string)
+lc(char *string)
 {
-  char *p = string, c;
-  while ((c = *p))
-    {
-      *p = tolower (c);
-      p++;
+    char *p = string, c;
+    while ((c = *p)) {
+	*p = tolower(c);
+	p++;
     }
 }
 
 
 void
-send_bh_or_ld (char *bhmessage, ntlm_authenticate * failedauth, int authlen)
+send_bh_or_ld(char *bhmessage, ntlm_authenticate * failedauth, int authlen)
 {
-  char *creds = NULL;
-  if (last_ditch_enabled)
-    {
-      creds = fetch_credentials (failedauth, authlen);
-      if (creds)
-	{
-	  lc (creds);
-	  SEND2 ("LD %s", creds);
-	}
-      else
-	{
-	  SEND ("NA last-ditch on, but no credentials");
-	}
-    }
-  else
-    {
-      SEND (bhmessage);
+    char *creds = NULL;
+    if (last_ditch_enabled) {
+	creds = fetch_credentials(failedauth, authlen);
+	if (creds) {
+	    lc(creds);
+	    SEND2("LD %s", creds);
+	} else {
+	    SEND("NA last-ditch on, but no credentials");
+	}
+    } else {
+	SEND(bhmessage);
     }
 }
 
@@ -129,418 +121,387 @@
 char *my_program_name = NULL;
 
 void
-usage ()
+usage()
 {
-  fprintf (stderr,
-	   "%s usage:\n"
-	   "%s [-b] [-f] domain\\controller [domain\\controller ...]\n"
-	   "-b, if specified, enables load-balancing among controllers\n"
-	   "-f, if specified, enables failover among controllers\n"
-	   "-l, if specified, changes behavior on domain controller failyures to" "\tlast-ditch\n\n" "You MUST specify at least one Domain Controller.\n" "You can use either \\ or / as separator between the domain name \n" "\tand the controller name\n", my_program_name, my_program_name);
+    fprintf(stderr,
+	"%s usage:\n"
+	"%s [-b] [-f] domain\\controller [domain\\controller ...]\n"
+	"-b, if specified, enables load-balancing among controllers\n"
+	"-f, if specified, enables failover among controllers\n"
+	"-l, if specified, changes behavior on domain controller failyures to" "\tlast-ditch\n\n" "You MUST specify at least one Domain Controller.\n" "You can use either \\ or / as separator between the domain name \n" "\tand the controller name\n", my_program_name, my_program_name);
 }
 
 
 void
-process_options (int argc, char *argv[])
+process_options(int argc, char *argv[])
 {
-  int opt, j, had_error = 0;
-  dc *new_dc = NULL, *last_dc = NULL;
-  while (-1 != (opt = getopt (argc, argv, "bfl")))
-    {
-      switch (opt)
-	{
+    int opt, j, had_error = 0;
+    dc *new_dc = NULL, *last_dc = NULL;
+    while (-1 != (opt = getopt(argc, argv, "bfl"))) {
+	switch (opt) {
 	case 'b':
-	  load_balance = 1;
-	  break;
+	    load_balance = 1;
+	    break;
 	case 'f':
-	  failover_enabled = 1;
-	  break;
+	    failover_enabled = 1;
+	    break;
 	case 'l':
-	  last_ditch_enabled = 1;
-	  break;
+	    last_ditch_enabled = 1;
+	    break;
 	default:
-	  fprintf (stderr, "unknown option: -%c. Exiting\n", opt);
-	  usage ();
-	  had_error = 1;
-	}
-    }
-  if (had_error)
-    exit (1);
-  /* Okay, now begin filling controllers up */
-  /* we can avoid memcpy-ing, and just reuse argv[] */
-  for (j = optind; j < argc; j++)
-    {
-      char *d, *c;
-      /* d will not be freed in case of non-error. Since we don't reconfigure,
-       * it's going to live as long as the process anyways */
-      d = malloc (strlen (argv[j]) + 1);
-      strcpy (d, argv[j]);
-      debug ("Adding domain-controller %s\n", d);
-      if (NULL == (c = strchr (d, '\\')) && NULL == (c = strchr (d, '/')))
-	{
-	  fprintf (stderr, "Couldn't grok domain-controller %s\n", d);
-	  free (d);
-	  continue;
-	}
-      /* more than one delimiter is not allowed */
-      if (NULL != strchr (c + 1, '\\') || NULL != strchr (c + 1, '/'))
-	{
-	  fprintf (stderr, "Broken domain-controller %s\n", d);
-	  free (d);
-	  continue;
-	}
-      *c++ = '\0';
-      new_dc = (dc *) malloc (sizeof (dc));
-      if (!new_dc)
-	{
-	  fprintf (stderr, "Malloc error while parsing DC options\n");
-	  free (d);
-	  continue;
-	}
-      /* capitalize */
-      uc (c);
-      uc (d);
-      numcontrollers++;
-      new_dc->domain = d;
-      new_dc->controller = c;
-      new_dc->status = DC_OK;
-      if (controllers == NULL)
-	{			/* first controller */
-	  controllers = new_dc;
-	  last_dc = new_dc;
-	}
-      else
-	{
-	  last_dc->next = new_dc;	/* can't be null */
-	  last_dc = new_dc;
-	}
-    }
-  if (numcontrollers == 0)
-    {
-      fprintf (stderr, "You must specify at least one domain-controller!\n");
-      usage ();
-      exit (1);
+	    fprintf(stderr, "unknown option: -%c. Exiting\n", opt);
+	    usage();
+	    had_error = 1;
+	}
+    }
+    if (had_error)
+	exit(1);
+    /* Okay, now begin filling controllers up */
+    /* we can avoid memcpy-ing, and just reuse argv[] */
+    for (j = optind; j < argc; j++) {
+	char *d, *c;
+	/* d will not be freed in case of non-error. Since we don't reconfigure,
+	 * it's going to live as long as the process anyways */
+	d = malloc(strlen(argv[j]) + 1);
+	strcpy(d, argv[j]);
+	debug("Adding domain-controller %s\n", d);
+	if (NULL == (c = strchr(d, '\\')) && NULL == (c = strchr(d, '/'))) {
+	    fprintf(stderr, "Couldn't grok domain-controller %s\n", d);
+	    free(d);
+	    continue;
+	}
+	/* more than one delimiter is not allowed */
+	if (NULL != strchr(c + 1, '\\') || NULL != strchr(c + 1, '/')) {
+	    fprintf(stderr, "Broken domain-controller %s\n", d);
+	    free(d);
+	    continue;
+	}
+	*c++ = '\0';
+	new_dc = (dc *) malloc(sizeof(dc));
+	if (!new_dc) {
+	    fprintf(stderr, "Malloc error while parsing DC options\n");
+	    free(d);
+	    continue;
+	}
+	/* capitalize */
+	uc(c);
+	uc(d);
+	numcontrollers++;
+	new_dc->domain = d;
+	new_dc->controller = c;
+	new_dc->status = DC_OK;
+	if (controllers == NULL) {	/* first controller */
+	    controllers = new_dc;
+	    last_dc = new_dc;
+	} else {
+	    last_dc->next = new_dc;	/* can't be null */
+	    last_dc = new_dc;
+	}
+    }
+    if (numcontrollers == 0) {
+	fprintf(stderr, "You must specify at least one domain-controller!\n");
+	usage();
+	exit(1);
     }
-  last_dc->next = controllers;	/* close the queue, now it's circular */
+    last_dc->next = controllers;	/* close the queue, now it's circular */
 }
 
 /* tries connecting to the domain controllers in the "controllers" ring,
  * with failover if the adequate option is specified.
  */
 const char *
-obtain_challenge ()
+obtain_challenge()
 {
-  int j = 0;
-  const char *ch;
-  debug ("obtain_challenge: getting new challenge\n");
-  for (j = 0; j < numcontrollers; j++)
-    {
-      if (current_dc->status == DC_OK)
-	{
-	  debug ("getting challenge from %s\%s\n", current_dc->domain, current_dc->controller);
-	  ch = make_challenge (current_dc->domain, current_dc->controller);
-	  if (ch)
-	    return ch;		/* All went OK, returning */
-	  /* Huston, we've got a problem. Take this DC out of the loop */
-	  debug ("Marking DC as DEAD\n");
-	  current_dc->status = DC_DEAD;
-	  need_dc_resurrection = 1;
-	}
-      if (failover_enabled == 0)	/* No failover. Just return */
-	return NULL;
-      /* Try with the next */
-      current_dc = current_dc->next;
+    int j = 0;
+    const char *ch;
+    debug("obtain_challenge: getting new challenge\n");
+    for (j = 0; j < numcontrollers; j++) {
+	if (current_dc->status == DC_OK) {
+	    debug("getting challenge from %s\%s\n", current_dc->domain, current_dc->controller);
+	    ch = make_challenge(current_dc->domain, current_dc->controller);
+	    if (ch)
+		return ch;	/* All went OK, returning */
+	    /* Huston, we've got a problem. Take this DC out of the loop */
+	    debug("Marking DC as DEAD\n");
+	    current_dc->status = DC_DEAD;
+	    need_dc_resurrection = 1;
+	}
+	if (failover_enabled == 0)	/* No failover. Just return */
+	    return NULL;
+	/* Try with the next */
+	current_dc = current_dc->next;
     }
-  /* DC (all DCs if failover is enabled) failed. */
-  return NULL;
+    /* DC (all DCs if failover is enabled) failed. */
+    return NULL;
 }
 
 
 void
-manage_request ()
+manage_request()
 {
-  ntlmhdr *fast_header;
-  char buf[BUFFER_SIZE];
-  const char *ch;
-  char *ch2, *decoded, *cred;
-  int plen;
-
-  if (fgets (buf, BUFFER_SIZE, stdin) == NULL)
-    {
-      fprintf (stderr, "fgets() failed! dying..... errno=%d (%s)\n", errno, strerror (errno));
-      abort ();
-      exit (1);			/* BIIG buffer */
-    }
-  debug ("managing request\n");
-  ch2 = memchr (buf, '\n', BUFFER_SIZE);	/* safer against overrun than strchr */
-  if (ch2)
-    {
-      *ch2 = '\0';		/* terminate the string at newline. */
-      ch = ch2;
-    }
-  debug ("ntlm authenticator. Got '%s' from Squid\n", buf);
-
-  if (memcmp (buf, "KK ", 3) == 0)
-    {				/* authenticate-request */
-      /* figure out what we got */
-      decoded = base64_decode (buf + 3);
-      /* Note: we don't need to manage memory at this point, since
-       *  base64_decode returns a pointer to static storage.
-       */
-
-      if (!decoded)
-	{			/* decoding failure, return error */
-	  SEND ("NA Packet format error, couldn't base64-decode");
-	  return;
-	}
-      /* fast-track-decode request type. */
-      fast_header = (struct _ntlmhdr *) decoded;
-
-      /* sanity-check: it IS a NTLMSSP packet, isn't it? */
-      if (memcmp (fast_header->signature, "NTLMSSP", 8) != 0)
-	{
-	  SEND ("NA Broken authentication packet");
-	  return;
+    ntlmhdr *fast_header;
+    char buf[BUFFER_SIZE];
+    const char *ch;
+    char *ch2, *decoded, *cred;
+    int plen;
+
+    if (fgets(buf, BUFFER_SIZE, stdin) == NULL) {
+	fprintf(stderr, "fgets() failed! dying..... errno=%d (%s)\n", errno, strerror(errno));
+	abort();
+	exit(1);		/* BIIG buffer */
+    }
+    debug("managing request\n");
+    ch2 = memchr(buf, '\n', BUFFER_SIZE);	/* safer against overrun than strchr */
+    if (ch2) {
+	*ch2 = '\0';		/* terminate the string at newline. */
+	ch = ch2;
+    }
+    debug("ntlm authenticator. Got '%s' from Squid\n", buf);
+
+    if (memcmp(buf, "KK ", 3) == 0) {	/* authenticate-request */
+	/* figure out what we got */
+	decoded = base64_decode(buf + 3);
+	/* Note: we don't need to manage memory at this point, since
+	 *  base64_decode returns a pointer to static storage.
+	 */
+
+	if (!decoded) {		/* decoding failure, return error */
+	    SEND("NA Packet format error, couldn't base64-decode");
+	    return;
+	}
+	/* fast-track-decode request type. */
+	fast_header = (struct _ntlmhdr *) decoded;
+
+	/* sanity-check: it IS a NTLMSSP packet, isn't it? */
+	if (memcmp(fast_header->signature, "NTLMSSP", 8) != 0) {
+	    SEND("NA Broken authentication packet");
+	    return;
 	}
-      switch (fast_header->type)
-	{
+	switch (fast_header->type) {
 	case NTLM_NEGOTIATE:
-	  SEND ("NA Invalid negotiation request received");
-	  return;
-	  /* notreached */
+	    SEND("NA Invalid negotiation request received");
+	    return;
+	    /* notreached */
 	case NTLM_CHALLENGE:
-	  SEND ("NA Got a challenge. We refuse to have our authority disputed");
-	  return;
-	  /* notreached */
+	    SEND("NA Got a challenge. We refuse to have our authority disputed");
+	    return;
+	    /* notreached */
 	case NTLM_AUTHENTICATE:
-	  /* check against the DC */
-	  plen = strlen (buf) * 3 / 4;	/* we only need it here. Optimization */
-	  cred = ntlm_check_auth ((ntlm_authenticate *) decoded, plen);
+	    /* check against the DC */
+	    plen = strlen(buf) * 3 / 4;		/* we only need it here. Optimization */
+	    cred = ntlm_check_auth((ntlm_authenticate *) decoded, plen);
 #ifdef OLDCRUFT
-	  if (cred == NULL)
-	    {
-	      int errorclass, errorcode;
+	    if (cred == NULL) {
+		int errorclass, errorcode;
 #ifdef DEBUG
-	      SMB_Get_Error_Msg (SMB_Get_Last_SMB_Err (), error_messages_buffer, BUFFER_SIZE);
-	      debug ("Authentication failure. SMB error: %d: %s\n. Class=%d, Code=%d\n", SMB_Get_Last_SMB_Err (), error_messages_buffer, SMB_Get_Last_SMB_Err () & 0xff, SMB_Get_Last_SMB_Err () >> 16);
-	      RFCNB_Get_Error_Msg (RFCNB_Get_Last_Error (), error_messages_buffer, BUFFER_SIZE);
-	      debug ("RFCNB error status: code=%d (%s)\n", RFCNB_Get_Last_Error (), error_messages_buffer);
+		SMB_Get_Error_Msg(SMB_Get_Last_SMB_Err(), error_messages_buffer, BUFFER_SIZE);
+		debug("Authentication failure. SMB error: %d: %s\n. Class=%d, Code=%d\n", SMB_Get_Last_SMB_Err(), error_messages_buffer, SMB_Get_Last_SMB_Err() & 0xff, SMB_Get_Last_SMB_Err() >> 16);
+		RFCNB_Get_Error_Msg(RFCNB_Get_Last_Error(), error_messages_buffer, BUFFER_SIZE);
+		debug("RFCNB error status: code=%d (%s)\n", RFCNB_Get_Last_Error(), error_messages_buffer);
 #endif
-	      /* This is kind of a special case, which happens when the
-	         client sends credentials in a domain which is not trusted
-	         by the domain we're using when authenticating. Unfortunately,
-	         it can't currently be accommodated in the current framework so
-	         I'll leave it hanging here, waiting for the general framework
-	         to be expanded to better accommodate the generale case. */
-	      errorclass = SMB_Get_Last_SMB_Err () & 0xff;
-	      errorcode = SMB_Get_Last_SMB_Err () >> 16;
-	      if (errorclass == 1 && errorcode == 5)
-		{
-		  SEND ("NA Wrong password or untrusted domain");
-		  return;
+		/* This is kind of a special case, which happens when the
+		 * client sends credentials in a domain which is not trusted
+		 * by the domain we're using when authenticating. Unfortunately,
+		 * it can't currently be accommodated in the current framework so
+		 * I'll leave it hanging here, waiting for the general framework
+		 * to be expanded to better accommodate the generale case. */
+		errorclass = SMB_Get_Last_SMB_Err() & 0xff;
+		errorcode = SMB_Get_Last_SMB_Err() >> 16;
+		if (errorclass == 1 && errorcode == 5) {
+		    SEND("NA Wrong password or untrusted domain");
+		    return;
 		}
-	      switch (ntlm_errno)
-		{
+		switch (ntlm_errno) {
 		case NTLM_LOGON_ERROR:
-		  SEND ("NA authentication failure");
-		  /* I must have been drugged when I wrote the following two lines */
-		  /* dc_disconnect();
-		     current_dc = current_dc->next; */
-		  return;
+		    SEND("NA authentication failure");
+		    /* I must have been drugged when I wrote the following two lines */
+		    /* dc_disconnect();
+		     * current_dc = current_dc->next; */
+		    return;
 		case NTLM_SERVER_ERROR:
-		  send_bh_or_ld ("BH Domain Controller Error", (ntlm_authenticate *) decoded, plen);
-		  /* SEND("BH Domain Controller Error"); */
-		  /* we don't really need to disconnect NOW.
-		     Besides, we asked squid to force a reconnect. This way, if we
-		     have authentications in flight, we might even succeed.
-		   */
-		  /* dc_disconnect(); */
-
-		  SMB_Get_Error_Msg (SMB_Get_Last_Error (), smb_error_buffer, 1000);
-		  debug ("Last error was: %s, RFC errno=%d\n", smb_error_buffer, RFCNB_Get_Last_Errno ());
-		  if (failover_enabled)
-		    current_dc = current_dc->next;
-		  return;
+		    send_bh_or_ld("BH Domain Controller Error", (ntlm_authenticate *) decoded, plen);
+		    /* SEND("BH Domain Controller Error"); */
+		    /* we don't really need to disconnect NOW.
+		     * Besides, we asked squid to force a reconnect. This way, if we
+		     * have authentications in flight, we might even succeed.
+		     */
+		    /* dc_disconnect(); */
+
+		    SMB_Get_Error_Msg(SMB_Get_Last_Error(), smb_error_buffer, 1000);
+		    debug("Last error was: %s, RFC errno=%d\n", smb_error_buffer, RFCNB_Get_Last_Errno());
+		    if (failover_enabled)
+			current_dc = current_dc->next;
+		    return;
 		case NTLM_PROTOCOL_ERROR:
-		  send_bh_or_ld ("BH Domain Controller communication error", (ntlm_authenticate *) decoded, plen);
-		  /* SEND("BH Domain Controller communication error"); */
-		  /* dc_disconnect(); */
-		  if (failover_enabled)
-		    current_dc = current_dc->next;
-		  return;
+		    send_bh_or_ld("BH Domain Controller communication error", (ntlm_authenticate *) decoded, plen);
+		    /* SEND("BH Domain Controller communication error"); */
+		    /* dc_disconnect(); */
+		    if (failover_enabled)
+			current_dc = current_dc->next;
+		    return;
 		case NTLM_NOT_CONNECTED:
-		  send_bh_or_ld ("BH Domain Controller (or network) died on us", (ntlm_authenticate *) decoded, plen);
-		  /* SEND("BH Domain Controller (or network) died on us"); */
-		  /* dc_disconnect(); */
-		  if (failover_enabled)
-		    current_dc = current_dc->next;
-		  return;
+		    send_bh_or_ld("BH Domain Controller (or network) died on us", (ntlm_authenticate *) decoded, plen);
+		    /* SEND("BH Domain Controller (or network) died on us"); */
+		    /* dc_disconnect(); */
+		    if (failover_enabled)
+			current_dc = current_dc->next;
+		    return;
 		case NTLM_BAD_PROTOCOL:
-		  send_bh_or_ld ("BH Domain controller failure", (ntlm_authenticate *) decoded, plen);
-		  /* SEND("BH Domain controller failure"); */
-/* dc_disconnect(); *//* maybe we're overreacting? */
-		  SMB_Get_Error_Msg (SMB_Get_Last_Error (), smb_error_buffer, 1000);
-		  debug ("Last error was: %s. RFCNB errno=%d\n", smb_error_buffer, RFCNB_Get_Last_Errno ());
-		  if (failover_enabled)
-		    current_dc = current_dc->next;
-		  return;
+		    send_bh_or_ld("BH Domain controller failure", (ntlm_authenticate *) decoded, plen);
+		    /* SEND("BH Domain controller failure"); */
+		    /* dc_disconnect(); *//* maybe we're overreacting? */
+		    SMB_Get_Error_Msg(SMB_Get_Last_Error(), smb_error_buffer, 1000);
+		    debug("Last error was: %s. RFCNB errno=%d\n", smb_error_buffer, RFCNB_Get_Last_Errno());
+		    if (failover_enabled)
+			current_dc = current_dc->next;
+		    return;
 		default:
-		  send_bh_or_ld ("BH Unhandled error while talking to Domain Controller", (ntlm_authenticate *) decoded, plen);
-		  /* SEND("BH Unhandled error while talking to Domain Controller"); */
-/* dc_disconnect(); *//* maybe we're overreacting? */
-		  if (failover_enabled)
-		    current_dc = current_dc->next;
-		  return;
+		    send_bh_or_ld("BH Unhandled error while talking to Domain Controller", (ntlm_authenticate *) decoded, plen);
+		    /* SEND("BH Unhandled error while talking to Domain Controller"); */
+		    /* dc_disconnect(); *//* maybe we're overreacting? */
+		    if (failover_enabled)
+			current_dc = current_dc->next;
+		    return;
 		}
 	    }
 #else /* OLDCRUFT */
-	  if (cred == NULL)
-	    {
-	      int smblib_err, smb_errorclass, smb_errorcode, nb_error;
-	      /* there was an error. We have two errno's to look at.
-	       * libntlmssp's erno is insufficient, we'll have to look at
-	       * the actual SMB library error codes, to acually figure
-	       * out what's happening. The thing has braindamaged interfacess..*/
-	      smblib_err = SMB_Get_Last_Error ();
-	      smb_errorclass = SMBlib_Error_Class (SMB_Get_Last_SMB_Err ());
-	      smb_errorcode = SMBlib_Error_Code (SMB_Get_Last_SMB_Err ());
-	      nb_error = RFCNB_Get_Last_Error ();
-	      debug ("No creds. SMBlib error %d, SMB error class %d, " "SMB error code %d, NB error %d\n", smblib_err, smb_errorclass, smb_errorcode, nb_error);
-	      /* Should I use smblib_err? Actually it seems I can do as well
-	       * without it.. */
-	      if (nb_error != 0)
-		{		/* netbios-level error */
-		  send_bh_or_ld ("NetBios error!", (ntlm_authenticate *) decoded, plen);
-		  fprintf (stderr, "NetBios error code %d (%s)\n", nb_error, RFCNB_Error_Strings[abs (nb_error)]);
-		  return;
+	    if (cred == NULL) {
+		int smblib_err, smb_errorclass, smb_errorcode, nb_error;
+		/* there was an error. We have two errno's to look at.
+		 * libntlmssp's erno is insufficient, we'll have to look at
+		 * the actual SMB library error codes, to acually figure
+		 * out what's happening. The thing has braindamaged interfacess..*/
+		smblib_err = SMB_Get_Last_Error();
+		smb_errorclass = SMBlib_Error_Class(SMB_Get_Last_SMB_Err());
+		smb_errorcode = SMBlib_Error_Code(SMB_Get_Last_SMB_Err());
+		nb_error = RFCNB_Get_Last_Error();
+		debug("No creds. SMBlib error %d, SMB error class %d, " "SMB error code %d, NB error %d\n", smblib_err, smb_errorclass, smb_errorcode, nb_error);
+		/* Should I use smblib_err? Actually it seems I can do as well
+		 * without it.. */
+		if (nb_error != 0) {	/* netbios-level error */
+		    send_bh_or_ld("NetBios error!", (ntlm_authenticate *) decoded, plen);
+		    fprintf(stderr, "NetBios error code %d (%s)\n", nb_error, RFCNB_Error_Strings[abs(nb_error)]);
+		    return;
 		}
-	      switch (smb_errorclass)
-		{
+		switch (smb_errorclass) {
 		case SMBC_SUCCESS:
-		  debug ("Huh? Got a SMB success code but could check auth..");
-		  SEND ("NA Authentication failed");
-		  /*
-		     send_bh_or_ld("SMB success, but no creds. Internal error?",
-		     (ntlm_authenticate *) decoded, plen);
-		   */
-		  return;
+		    debug("Huh? Got a SMB success code but could check auth..");
+		    SEND("NA Authentication failed");
+		    /*
+		     * send_bh_or_ld("SMB success, but no creds. Internal error?",
+		     * (ntlm_authenticate *) decoded, plen);
+		     */
+		    return;
 		case SMBC_ERRDOS:
-		  /*this is the most important one for errors */
-		  debug ("DOS error\n");
-		  switch (smb_errorcode)
-		    {
-		      /* two categories matter to us: those which could be
-		         server errors, and those which are auth errors */
+		    /*this is the most important one for errors */
+		    debug("DOS error\n");
+		    switch (smb_errorcode) {
+			/* two categories matter to us: those which could be
+			 * server errors, and those which are auth errors */
 		    case SMBD_noaccess:	/* 5 */
-		      SEND ("NA Access denied");
-		      return;
+			SEND("NA Access denied");
+			return;
 		    case SMBD_badformat:
-		      SEND ("NA bad format in authentication packet");
-		      return;
+			SEND("NA bad format in authentication packet");
+			return;
 		    case SMBD_badaccess:
-		      SEND ("NA Bad access request");
-		      return;
+			SEND("NA Bad access request");
+			return;
 		    case SMBD_baddata:
-		      SEND ("NA Bad Data");
-		      return;
+			SEND("NA Bad Data");
+			return;
 		    default:
-		      send_bh_or_ld ("DOS Error", (ntlm_authenticate *) decoded, plen);
-		      return;
+			send_bh_or_ld("DOS Error", (ntlm_authenticate *) decoded, plen);
+			return;
 		    }
 		case SMBC_ERRSRV:	/* server errors */
-		  debug ("Server error");
-		  switch (smb_errorcode)
-		    {
-		      /* mostly same as above */
+		    debug("Server error");
+		    switch (smb_errorcode) {
+			/* mostly same as above */
 		    case SMBV_badpw:
-		      SEND ("NA Bad password");
-		      return;
+			SEND("NA Bad password");
+			return;
 		    case SMBV_access:
-		      SEND ("NA Server access error");
-		      return;
+			SEND("NA Server access error");
+			return;
 		    default:
-		      send_bh_or_ld ("Server Error", (ntlm_authenticate *) decoded, plen);
-		      return;
+			send_bh_or_ld("Server Error", (ntlm_authenticate *) decoded, plen);
+			return;
 		    }
 		case SMBC_ERRHRD:	/* hardware errors don't really matter */
-		  send_bh_or_ld ("Domain Controller Hardware error", (ntlm_authenticate *) decoded, plen);
-		  return;
+		    send_bh_or_ld("Domain Controller Hardware error", (ntlm_authenticate *) decoded, plen);
+		    return;
 		case SMBC_ERRCMD:
-		  send_bh_or_ld ("Domain Controller Command Error", (ntlm_authenticate *) decoded, plen);
-		  return;
+		    send_bh_or_ld("Domain Controller Command Error", (ntlm_authenticate *) decoded, plen);
+		    return;
 		}
 	    }
 #endif /* OLDCRUFT */
-	  lc (cred);		/* let's lowercase them for our convenience */
-	  SEND2 ("AF %s", cred);
-	  return;
+	    lc(cred);		/* let's lowercase them for our convenience */
+	    SEND2("AF %s", cred);
+	    return;
 	default:
-	  SEND ("BH unknown authentication packet type");
-	  return;
+	    SEND("BH unknown authentication packet type");
+	    return;
 	}
 
 
-      return;
+	return;
     }
-  if (memcmp (buf, "YR", 2) == 0)
-    {				/* refresh-request */
-      dc_disconnect ();
-      ch = obtain_challenge ();
-      /* Robert says we can afford to wait forever. I'll trust him on this
-         one */
-      while (ch == NULL)
-	{
-	  sleep (30);
-	  ch = obtain_challenge ();
-	}
-      SEND2 ("TT %s", ch);
-      if (need_dc_resurrection)	/* looks like a good moment... */
-	resurrect_dead_dc ();
-      return;
+    if (memcmp(buf, "YR", 2) == 0) {	/* refresh-request */
+	dc_disconnect();
+	ch = obtain_challenge();
+	/* Robert says we can afford to wait forever. I'll trust him on this
+	 * one */
+	while (ch == NULL) {
+	    sleep(30);
+	    ch = obtain_challenge();
+	}
+	SEND2("TT %s", ch);
+	if (need_dc_resurrection)	/* looks like a good moment... */
+	    resurrect_dead_dc();
+	return;
     }
-  SEND ("BH Helper detected protocol error");
-  return;
+    SEND("BH Helper detected protocol error");
+    return;
 /********* END ********/
 
 
 }
 
 int
-main (int argc, char *argv[])
+main(int argc, char *argv[])
 {
 
-  debug ("ntlm_auth build " __DATE__ ", " __TIME__ " starting up...\n");
+    debug("ntlm_auth build " __DATE__ ", " __TIME__ " starting up...\n");
 #ifdef DEBUG
-  debug ("changing dir to /tmp");
-  chdir ("/tmp");
+    debug("changing dir to /tmp");
+    chdir("/tmp");
 #endif
 
-  my_program_name = argv[0];
-  process_options (argc, argv);
+    my_program_name = argv[0];
+    process_options(argc, argv);
 
-  debug ("options processed OK\n");
+    debug("options processed OK\n");
 
-  /* initialize FDescs */
-  setbuf (stdout, NULL);
-  setbuf (stderr, NULL);
-
-  /* select the first domain controller we're going to use */
-  current_dc = controllers;
-  if (load_balance != 0 && numcontrollers > 1)
-    {
-      int n;
-      pid_t pid = getpid ();
-      n = pid % numcontrollers;
-      debug ("load balancing. Selected controller #%d\n", n);
-      while (n > 0)
-	{
-	  current_dc = current_dc->next;
-	  n--;
-	}
-    }
-  while (1)
-    {
-      manage_request ();
+    /* initialize FDescs */
+    setbuf(stdout, NULL);
+    setbuf(stderr, NULL);
+
+    /* select the first domain controller we're going to use */
+    current_dc = controllers;
+    if (load_balance != 0 && numcontrollers > 1) {
+	int n;
+	pid_t pid = getpid();
+	n = pid % numcontrollers;
+	debug("load balancing. Selected controller #%d\n", n);
+	while (n > 0) {
+	    current_dc = current_dc->next;
+	    n--;
+	}
+    }
+    while (1) {
+	manage_request();
     }
-  return 0;
+    return 0;
 }
